/*
 * FILE     : sscvect2.h
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : xN^[ev[giy[Wǉmی^jvec.v[]͎gȂ
              sscvect2.cppƃZbgŎg
 * AUTHER   : N.Tsuchiya  2004.05.18
 *          : K.Hirano    2004.08.17
 */

#if ! defined(SSCVECT2pH)
#define SSCVECT2pH

#include	<stdlib.h>
//#include	<malloc.h>
#include	<memory.h>

//#define		Eprintf	printf
#define		PAGEMAX		1000
#define		PAGESIZE	4194304  /* 4M */

/* }X^i[ev[g */
template <class T>
class sscvect2 {
	// vf֘Aϐ
	int		n;              /* vfmې */
	int		x;              /* vfő吔 */
	// y[W֘Aϐ
	int 	epp;            /* Py[WɊi[łz [max Element num Per Page] */
	T		*addr[PAGEMAX]; /* y[W̐擪AhXz */
	int 	pn;             /* gpy[W(mۃy[W) */
	int 	eidx;           /* ŏIy[W̍ŏICfbNX(̊i[ʒu|P) */
public:
	sscvect2() { init(); }      //RXgN^
//	~sscvect2() { final(); }    //fXgN^
	TIL_sscvect2() { final(); }    //fXgN^
	int push_back(const T &x);                    //PvfǉAYԂ
	T	*peep(int idx){ return get(idx);} //v[idx]̃|C^Ԃ
	T	&operator[](int idx){ return *get(idx);}
	T	*begin(){ return &addr[0][0];}
	T	*end(){ return &addr[pn-1][eidx];}
	void clear(){ n = 0; pn = 1; eidx = -1; }
	int assign(T *first, T *last);
	int size(){ return n; }
	int resize(int size);
	int resize(int size,const T &e);
private:
	int expand();
	int init();
	void final();
	T *get(int idx);
};
/*	ID_expand_com	z̊g
***************************************************************************/
template <class T> int sscvect2<T>::expand()
{
	int		rc = -1;
	T		*pwk;
	
	if( x <= 0 || n >= x ) {               //CHKB(1, 1, nsz);
		if( (pwk = (T*)malloc(PAGESIZE)) == NULL) goto           err;
		if (pn >= PAGEMAX) goto                                  err;
		addr[pn++] = pwk;
		x += epp;
		eidx = -1;
	}
	memset(&addr[pn-1][++eidx], 0, sizeof(T));
	rc = n++;
quit:
	return( rc );
err: rc = -1;
	goto                                                         quit;
}

/*	ID_push_back	z̒ǉ
***************************************************************************/
template <class T> int sscvect2<T>::push_back(const T &e) {
	int 	rc;
	//z̊g
	if( (rc = expand()) < 0 ) goto                               quit;
	addr[pn-1][eidx] = e;
	rc = n;
quit:
	return rc;
}

/*	ID_resize	z̒ǉ
***************************************************************************/
template <class T> int sscvect2<T>::resize(int size) {
	int 	rc;
	//z̊g
	while (n < size) {
		if( (rc = expand()) < 0 ) goto                           quit;
	}
quit:
	return rc;
}

/*	ID_resize	z̊gƏ
***************************************************************************/
template <class T> int sscvect2<T>::resize(int size,const T &e) {
	int 	rc;
	register T *p;
	//z̊g
	while (n < size) {
		if( (rc = expand()) < 0 ) goto                           quit;
		p = get(rc);
		*p = e;
	}
quit:
	return rc;
}

/*	ID_assign	z̒ǉ
***************************************************************************/
template <class T> int sscvect2<T>::assign(T *first, T *last) {
	int 	rc;
	//z̊g
	clear();
	while( first < last ) {
		if( push_back(*first++) < 0 ) goto                       quit;
	}
	rc = n;
quit:
	return rc;
}

/*	ID_init	z̏
***************************************************************************/
template <class T> int sscvect2<T>::init()
{
	int		i, rc = 0;
	int		size = sizeof(T);

	n = x = pn = 0;
	if( size <= 0 ) goto                                         err;
	if( size > PAGESIZE ) goto                                   err2;
	epp = PAGESIZE / size;
	for( i = 0; i < PAGEMAX; i++ ) { addr[i] = NULL; }
	eidx = -1;
quit:
	return( rc );
err:
	rc = -1;
	goto                                                         quit;
err2:
	rc = -1;
	goto                                quit;
}

/*	ID_final	z̉
***************************************************************************/
template <class T> void sscvect2<T>::final()
{
	int		i;

	for( i = 0; i < PAGEMAX; i++ ) {
		if( addr[i] != NULL ) { free(addr[i]); addr[i] = NULL; }
	}
	n = x = pn = epp = 0;
	eidx = -1;
}

/*	ID_get_pos	ʂCfbNXy[WԍEy[WAhX擾
***************************************************************************/
template <class T> T *sscvect2<T>::get(
	int		idx)		/* i  ʂCfbNX */
{
	int pno, pos;
	pno = idx / epp;  /* y[WCfbNX̎擾 */
	pos = idx % epp;  /* y[Wł̗vf̃CfbNX擾 */
	return &addr[pno][pos];
}

/////////////////////////////////////////////////////////////////

#endif // ! defined(SSCVECT2pH)
