/***********************************************************************
 * File     : lbuf.cpp
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * Function : CӒ̕Ԃ󂯂Ɋi[B
 * Auther   : N.HONAGA	94.03.10   N.Tsuchiya 1994.05.19
			  K.Hirano	00.08.03  Lgpp~ lbuf_reuseǉ
 */
static char	*__file =__FILE__;     /* should be copied into all .c files   */
#include    <stdio.h>
#include	<stdlib.h>
#include    <string.h>
#include    "zmrpssc.h"
#include	"zchardif.h"
/* #include	"lbuf.h" */

#if ! defined(Dprintf)
# define 	Dprintf	printf
#endif

//#define SEG_SIZE    16384
#define SEG_SIZE    32768
#define MAX_ID  50  //NT040422 20==>50

static int  init_flag = 0;  /* tO 0: 1:ς */
struct lblock {
	struct lblock	*pred;  /* O̎gpubNւ̃|C^ */
	struct lblock	*next;  /* ̎gpubNւ̃|C^ */
	unsigned int 	byte;  /* gp̍Ō̃ubN̎gpς݃oCg */
	char   segt[SEG_SIZE];  /* i[obt@ */
};
static struct lblock	*idtb[MAX_ID];

static int  Dirmalloc(
	struct lblock	**pwk,
	unsigned int 	size)
{
	int   rc= 0;
	if( (*pwk =(struct lblock*) malloc(size)) == NULL ) {  CHKA(0, 0, -1);
//J		 Dprintf( "**** error lbuf.c GAmۂłȂB" CR );
		 Dprintf( "**** error lbuf.c malloc errorB" CR );
		rc= -1;
	}
	return( rc );
}
static int Newblock(
	int 	id)
{
	int 	rc = -1;
	struct lblock	*pwk;
	if ( idtb[id] == NULL ) {
//		if( (pwk = (struct lblock*)Dirmalloc(sizeof(*pwk))) == NULL ) goto quit;
		if( (rc = Dirmalloc(&pwk, sizeof(*pwk))) < 0 ) goto quit;
		pwk->pred = pwk->next = NULL;
	} else if ((pwk = idtb[id]->next) == NULL) {
//		if( (pwk = (struct lblock*)Dirmalloc(sizeof(*pwk))) == NULL ) goto quit;
		if( (rc = Dirmalloc(&pwk, sizeof(*pwk))) < 0 ) goto quit;
		pwk->pred = idtb[id];
		pwk->next = NULL;
		idtb[id]->next = pwk;
	}
	idtb[id] = pwk;
	pwk->byte = 0;
	rc = 0;
quit:
	return( rc );
}
char *lbuf_add(
	int    id,   /* obt@ʎqB0`19idtb[]̈ʒu */
	char   *str, /* BoCif[^łǂB */
	int    len)  /* '\0'܂ޕ B0̎strlen(str)+1vZB */
{
	int 	ofs = 0;
	char	*src = NULL;
	                          CHKB(0,init_flag,1); CHKA(0,id,MAX_ID);
	if( ! init_flag ) {       /* */
		memset( idtb, 0, sizeof(idtb) );
		init_flag = 1;
	}
	if( str == NULL ) goto                                  quit;
	if( id < 0 || id >= MAX_ID ) goto                       err1;
	if( len <= 0 ) len = strlen(str) + 1;
	if( len > SEG_SIZE ) goto                               err1;
	if( idtb[id] ) ofs = idtb[id]->byte;
	if( idtb[id] == NULL || len + ofs > SEG_SIZE ) { /* 肫ȂƂ */
		if( Newblock(id) < 0 ) goto                  quit;
		ofs = 0;
	}                               CHKA(0,ofs,SEG_SIZE);
	src = &idtb[id]->segt[ofs];
	idtb[id]->byte = ofs + len;
	memcpy( src, str, len );
quit:
	return( src );
err1:   CHKA(0, 0, -1);
//J	Dprintf( "**** error lbuf_add()̃p[^id(%d)len(%d)słB" CR, id, len);
	Dprintf( "**** error lbuf_add() parameter error id(%d)len(%d)" CR, id, len);
	goto     quit;
}
int lbuf_free(
	int    id)     /* idtb[]̈ʒu */
{
	int    rc = 0;
	struct lblock	*pwk, *pred, *next;
	                         CHKB(0,init_flag,1); CHKA(0,id,MAX_ID);
	if( !init_flag ) goto                                          quit;
	if( id < 0 || id >= MAX_ID ) goto                          err1;
	for (pwk = idtb[id], next = NULL; pwk; pwk = pwk->next)  /* ͍Ō̎gpobt@ */
		next = pwk;
	for( pwk = next; pwk; pwk = pred )  {
		pred = pwk->pred;
		free( pwk );
	}
	idtb[id] = NULL;
quit:
	return( rc );
err1: rc = -1;   CHKA(0, 0, -1);
//J	Dprintf("**** lbuf_free()id(%d)p[^słB" CR, id );
	Dprintf("**** lbuf_free()parameter error id(%d)" CR, id );
	goto                                        quit;
}
int lbuf_reuse(
	int		id)		/* idtb[]̈ʒu */
{
	int    rc = 0;
	struct lblock	*pwk, *pred;
	                         CHKB(0,init_flag,1); CHKA(0,id,MAX_ID);
	if( !init_flag ) goto                                          quit;
	if( id < 0 || id >= MAX_ID ) goto                          err1;
	for( pwk = idtb[id], pred = NULL; pwk; pwk = pwk->pred )
		pred = pwk;
	if ( pred != NULL ) {  /* idʃobt@gpςȂ */
		idtb[id] = pred;
		idtb[id]->byte = 0;
	}
quit:
	return( rc );
err1: rc = -1;  CHKA(0, 0, -1);
//J	Dprintf("**** lbuf_reuse()id(%d)p[^słB" CR, id );
	Dprintf("**** lbuf_reuse()parameter error id(%d)" CR, id );
	goto                                        quit;
}
int lbuf_allfree()
{
	int 	id, rc;
	if( !init_flag ) return( 0 );
	for( id = 0 ; id < MAX_ID ; ++id )
		rc = lbuf_free( id );
	init_flag = 0;
	return( 0 );
}
int lbuf_allclear() { return (lbuf_allfree()); }
