/*
 * FILE      : zcalend.cpp	J_̍쐬
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : J_̍쐬
 * AUTHOR    : H.Yamagiwa  2004.09.27
 */
static char  *__file =__FILE__;  /* should be copied into all .c files */
#include <stdio.h>
#include <string.h>
#include "z1mrp.h"

#define	ISLEAP(y) ((y)%4?0:(y)%100?1:(y)%400?0:1) /*邤N̔ */
static int mday[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
static int tday[13] = {0,31,59,90,120,151,181,212,243,273,304,334,365};

/*	ID_zcalmak01	ʎZ[NΉJ_쐬
********************************************************/
int zcalmak01(ZMRP &g)
{
	int		rc = 0;
	int     i, y, m, d;

	if( (rc = g.cal.resize( g.endtd+1 )) < 0 ) goto                     quit;
	g.today = g.sys.pastdays;   /* ̒ʎZ ȗl:VXet cal[] */
	/*疢֐ݒ */
	y = g.sys.bday.y;
	m = g.sys.bday.m;
	d = g.sys.bday.d;
	mday[2] = 28 + ISLEAP(y+g.baseyear);
	for( i = g.today; i <= g.endtd; ++i ) {
		g.cal.v[i].y = y ;
		g.cal.v[i].m = m ;
		g.cal.v[i].d = d ;
		sprintf( g.cal.v[i].ymd, "%04d%02d%02d", y+g.baseyear, m, d );
		if( ++d > mday[m] ) {
			d -= mday[m];
			if( ++m > 12 ) { m = 1; y++; mday[2] = 28 + ISLEAP(y+g.baseyear); }
		}
	}
	y = g.sys.bday.y;
	m = g.sys.bday.m;
	d = g.sys.bday.d - 1;
	mday[2] = 28 + ISLEAP(y+g.baseyear);
	/* ߋ̐ݒ */
	for( i = g.today-1; i >= 0; --i ) {
		if( d <= 0 ){
			if( --m <= 0 ) { m = 12; y--; mday[2] = 28 + ISLEAP(y+g.baseyear); }
			d = mday[m];
		}
		g.cal.v[i].y = y ;
		g.cal.v[i].m = m ;
		g.cal.v[i].d = d ;
		sprintf( g.cal.v[i].ymd, "%04d%02d%02d", y+g.baseyear, m, d );
		--d;
	}
	rc = g.cal.size();
quit:
	return( rc );
}
/*	ID_Binary	N̂Q
********************************************************/
static int
Binary(ZMRP &g, int *t, int y, int m, int d)
{
	register int 	low, high, mid, rc = 0;
	register cal_td *pcal;

	mid = -1; //add NT140612 warning C4701 
	for ( low = 0, high = g.endtd ; low <= high ; ){
		mid = (low + high) >> 1;
		pcal = &g.cal.v[mid];
		if      (y < pcal->y) high = mid - 1;
		else if (y > pcal->y) low  = mid + 1;
		else if (m < pcal->m) high = mid - 1;
		else if (m > pcal->m) low  = mid + 1;
		else if (d < pcal->d) high = mid - 1;
		else if (d > pcal->d) low  = mid + 1;
		else	break;
    }
	if( low <= high )
		*t = rc = mid; 
	else if( high < 0 ) {
		*t = high; rc = -2;
	} else if( low > g.endtd ) {
		*t = low; rc = -2;
	}

	return( rc ); 
}
/*	ID_zmd_td2ymd1	ʎZNԂ
********************************************************/
int zmd_td2ymd1(ZMRP &g, int t, int *y, int *m, int *d)
{
	int		rc = 0;
	register cal_td	*pcal;
	                                    CHKB(0, t, g.endtd);
	if( t > g.endtd) { t = g.endtd; rc = -1;
	} else if( t < 0 ) { t = 0; rc = -1;
	}
	pcal = &g.cal.v[t];
	*y = pcal->y;
    *m = pcal->m;     CHKB(1, *m, 12);
	*d = pcal->d;     CHKB(1, *d, 31);
	rc = 0;
//quit:
	if(zdbgf[101])TRACEC(0), Dprintf("td2ymd1 rc(%d) t(%d) y(%d) m(%d) d(%d)" CR,rc,t,*y,*m,*d ); 
	return(rc);
//KS140603del	goto                                                                quit;
}
/*	ID_zmd_td1	NʎZւ̕ϊP
********************************************************/
int zmd_td1( ZMRP &g, int *t, int y, int m, int d )
{
	int		rc = 0; //, chkf = 1;
	int		t1, y1, m1, d1;
	                                    
	if(zdbgf[101]) {TRACEA(0); Dprintf("zmd_td1 y(%d)m(%d)d(%d)" CR, y, m, d);}
	if( y >= g.baseyear ) y -= g.baseyear;
						CHKB(0, y, y); CHKB(1, m, 12); CHKB(1, d, 31);
	rc = Binary(g, t, y, m, d);
									CHKB(-2, rc, rc);
	if( rc >= 0 ) {
		t1 = *t;
		rc = zmd_td2ymd1( g, t1, &y1, &m1, &d1);
		if( y1 != y || m1 != m || d1 != d ){
			*t = -1 ;
			rc = -1 ;
		}
	}
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmd_td1 t(%d)rc(%d)" CR, *t, rc);}
	return( rc ) ;
}
#if 0
/* @Ni\́jʎZւ̕ϊQ@ */
int
md_td2( t, ymd )
	int		*t;
	struct mcal_st *ymd ;
{
	int		rc = 0;
 
	if(DBG[252])TRACEA(0), DPprintf(elfp,"td2 ymd->y(%d)ymd->m(%d)ymd->d(%d)mn.cal(%d) " CR,ymd->y,ymd->m,ymd->d,mn.cal);
	if( ymd->y < 200) ymd->y = 1900 + ymd->y;
	rc = Binary(t, ymd->y, ymd->m, ymd->d);		/*CHKB(0, rc, rc); */
				/* CHKB(-2, rc, rc);  by M.Watanabe 3.2.20 */
	if(DBG[252])TRACEC(0),DPprintf(elfp,"td2 rc(%d)ymd->t(%d)ymd->y(%d)ymd->m(%d)d(%d)mn.cal(%d) " CR,rc,*t,ymd->y,ymd->m,ymd->d,mn.cal );
	return( rc ) ;
}
#endif
/*	ID_zmd_str2td	yyyymmdd񂩂ʎZɕϊ
********************************************************/
int zmd_str2td( ZMRP &g,
	char	*s,         /* i yyyymmdd */
	int 	*td,        /* o ʎZBXy[X̂Ƃ͂O <0:G[ */
	int 	dflt)       /* Xy[X̂Ƃ̏o͒lB-1:Xy[X̂Ƃ̓G[ */
{
	int 	rc = -1, yy, mm, dd;

	*td = dflt;
	if( *s ) {
		if( sscanf( s, "%4d%2d%2d", &yy, &mm, &dd ) != 3 ) goto           quit;
		if( yy < g.baseyear || yy > 2200 ) *td = dflt;
		else
			rc = zmd_td1( g, td, yy, mm, dd );
	} else {   /* yyyymmdd񂪃Xy[X */
		if( dflt >= 0 ) rc = 0;
	}
quit:
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmd_str2td td(%d)rc(%d)" CR, *td, rc);}
	return( rc );
}

/*	ID_zmd_ym2nd	SNA炻̌̓Ԃ
********************************************************/
int zmd_ym2nd(
	int yy, int mm )     /* i N */
{
	int 	rc = -1;
	                                    CHKB(2000, 2000, yy);
	if( mm == 2 ) {
		rc = 28 + ISLEAP( yy );
	} else if( mm >= 1 && mm <= 12 ) {
		rc = mday[mm];
	} else {                             CHKB(1, mm, 12);
		rc = 30;
	}
	return( rc );
}
/*	ID_zmd_dayyobi	SNAAjԂB06ŁAjyj\B
********************************************************/
int zmd_dayyobi(
	int	y1, int m1, int d1)
{
	int 	lday, rc = 0, leap;
												CHKB(1000, y1, y1);
	leap = ISLEAP(y1);                 //KS140603chg  ړ
	if( m1 <= 0 ) {						CHKB(1, m1, 12);
		lday = 0; //add NT140612 warning C4701 
	} else if( m1 <= 2 ) {
		mday[2] = 28 + leap;           //KS140603add
		if( d1 > mday[m1] )										goto	quit;
		lday = tday[m1-1] + d1 + y1 + (y1-1)/4 - (y1-1)/100 + (y1-1)/400 + 6;
	} else if( m1 <= 12 ) {
//KS140603chg		leap = ISLEAP(y1);  Ɉړ
//KS140603chg		mday[2] = 28 + leap;
		if( d1 > mday[m1] )										goto	quit;
		lday = tday[m1-1] + d1 + leap + y1 + (y1-1)/4 - (y1-1)/100 + (y1-1)/400 + 6;
	} else {     						CHKB(1, m1, 12);
		lday = 0; //add NT140612 warning C4701 
	}
	rc = lday % 7;
quit:
	return(rc);
}

#if 0
/* yyyymm񂩂P̒ʎZɕϊ */
md_sm2td( s, td, yy, mm, dflt )
	char	*s;         /* i yyyymm */
	int 	*td;        /* o ʎZBXy[X̂Ƃ͂O <0:G[ */
	int 	*yy, *mm;   /* o N */
	int 	dflt;       /* Xy[X̂Ƃ̏o͒lB-1:Xy[X̂Ƃ̓G[ */
{
	int 	rc = -1;

	if( *s ) {
		if( sscanf( s, "%4d%2d", yy, mm ) == 2 )
			rc = md_td1( td, *yy, *mm, 1 );
	} else {   /* yyyymm񂪃Xy[X */
		*td = dflt;
		*yy = *mm = 0;
		if( dflt >= 0 ) rc = 0;
	}
	if(DBG[255])TRACEB(0),DPprintf(elfp,"sm2td rc(%d) s(%s) td(%d) yy(%d) mm(%d) dflt(%d) " CR, rc, s, *td, *yy, *mm, dflt );
	return( rc );
}
#endif
static	 char	bf[5][16]; //boundchecker ŃG[o邽߂ɁAړ NT140610
/*	ID_zmd_td2str	ʎZyyyymmddɕϊ
********************************************************/
char	*zmd_td2str( ZMRP &g,
	char	*s,         /* o yyyymmdd NULLłǂ */
	int 	td)         /* i ʎZBXy[X̂Ƃ͂O <0:G[ */
{
//	int 	rc = -1; //, yy, mm, dd;
	char	*ws;
	static int sel = 0;
//	static char	bf[5][16]; //printf()̒ŁAőŤĂяo
	ws = s;
	if( s == NULL ) ws = bf[sel];
	if( ++sel >= 5 ) sel -= 5;
	if( td >= 0 && td <= g.endtd ) {
//		zmd_td2ymd1(g, td, &yy, &mm, &dd);
//		if( yy < g.baseyear ) yy += g.baseyear; /* N */
//		sprintf( ws, "%04d%02d%02d", yy, mm, dd );
		strcpy( ws, g.cal.v[td].ymd );
	} else {
		sprintf( ws, "%8s", "" );
	}
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmd_td2str s(%s) td(%d) " CR, ws, td);}
	return( ws );
}
#if 0
/* ʎZʎZɕϊ */
md_td2tm( td, tm )
	int 	td;         /* i ʎZ */
	int 	*tm;        /* o ʎZ ̒ʎZ͂PƂ */
{
	int 	rc = 0, yy1, yy2, mm1, mm2, dd1, dd2;

	if( td == 0 ) { /* t󔒂̂Ƃ̑Ή */
		*tm = 0;
	} else {
		md_td2ymd1(mc.today, &yy1, &mm1, &dd1);
		md_td2ymd1(td      , &yy2, &mm2, &dd2);
		*tm = (yy2 - yy1) * 12 + mm2 - mm1 + 1;    CHKA(0, *tm, 13);
	}
	if( *tm <  0  ) *tm = 0;
	if( *tm >= 13 ) *tm = 12;
	if(DBG[257])TRACEB(0),DPprintf(elfp,"td2tm td(%d) tm(%d)" CR, td, *tm );
	return( *tm );
}
#endif

/*	ID_zmd_zurasi2	VbvJ_ɏ]ĉғ炵(g.today-1..g.endtd)Ԃ
********************************************************/
int zmd_zurasi2( ZMRP &g,
	int 	aclm,     /* i J_        clm[]̓Y */
	int 	td,       /* i ʎZ          cal[]̓Y */
	int 	zure)     /* i ғ(ok)               */
{
	int		day;
	                                                  CHKA(0, aclm, g.clm.n);
	if(zdbgf[101]) {TRACEA(0); Dprintf("zmd_zurasi aclm(%d)td(%d)zure(%d)" CR, aclm, td, zure);}
	if( aclm < 0 || aclm >= g.clm.n ) { day = 0; goto                              quit; }
	day = zmd_zurasi( g, aclm, td, zure );
	if( day < g.today-1 ) day = g.today-1;
	if( day > g.endtd )   day = g.endtd;
quit:
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmd_zurasi day(%d)" CR, day);}
	return( day );
}
/*	ID_zmd_zurasi	VbvJ_ɏ]ĉғ炵(-1..g.endtd)Ԃ
********************************************************/
int zmd_zurasi( ZMRP &g,
	int 	aclm,     /* i J_        clm[]̓Y */
	int 	day,      /* i ʎZ          cal[]̓Y */
	int 	zure)     /* i ғ(ok)               */
{
	char	*holday;
	                              CHKA(0, aclm, g.clm.n); CHKB(0, day, g.endtd);
		                          CHKB(-120, zure, 120);
	if( aclm < 0 || aclm >= g.clm.n ) goto                              quit;
	if( day >= 0 && day <= g.endtd ) {
		holday = &g.clm.v[aclm].cal[0];
		                                            CHKB(0, holday[day], 1);
		if( zure > 0 ) {                            CHKB(0, 0, day);
			for( day++; day <= g.endtd; day++ ) {
				if( holday[day] == 0 ) continue;
				if( --zure <= 0 ) break;
			}
		} else if( zure < 0 ) {                     CHKB(day, day, g.endtd);
			for( day--; day >= 0; day-- ){
				if( holday[day] == 0 ) continue;
				if( ++zure >= 0 ) break;
			}
		}
	}
	if( day < 0 )       day = 0;
	if( day > g.endtd ) day = g.endtd;
quit:
	return( day );
}

/*	ID_zmd_kimatu1	̔z
********************************************************/
static int zmd_kimatu1( ZMRP &g,
	int mx,     // i  Nx̌
	int dx,     // i  Nx̓
	int k0)     // i  Nx̊񐔁1,2,3,4,6,12
{
	static int ye, me, de, y0, m0, d0;
	int		yy, mm, dd, td, k, y, rc, nn, cnt = 0;
	static int second = 0;
	                   CHKB(1, mx, 12); CHKB(1, dx, 31);
	if( k0 != 1 && k0 != 2 && k0 != 3 && k0 != 4 && k0 != 6 && k0 != 12 ) { CHKB(12, k0, 1);
		k0 = 1;
	}
	rc  = -1;
	if( second == 0 ) {
		second = 1;
		/* I̔NAA߂ */
		if( (rc = zmd_td2ymd1(g, g.endtd, &ye, &me, &de)) < 0 ) goto		quit;
		/* ʎZO̔NAA߂ */
		if( (rc = zmd_td2ymd1(g, 0, &y0, &m0, &d0)) < 0 ) goto		quit;
	}
	/* ̌߂ */
	nn = 12 / k0;
	/* ʎZȎONA߂ */
	for( y = y0 - 1; y <= ye; ++y ) {
		mday[2] = 28 + ISLEAP(y+g.baseyear);
		yy = y;
		mm = mx;
		for( k = 0; k < k0; ++k ){
			mm += nn;
			if( mm > 12 ) {
				mm -= 12;
				++yy;
				mday[2] = 28 + ISLEAP(yy+g.baseyear);
			}
			dd = dx;
			if( dd > mday[mm] ) dd = mday[mm];
			/* ʎZOO̓XLbv */
			if( yy < y0 || (yy == y0 && mm < m0) || (yy == y0 && mm == m0 && dd < d0) ) continue;
			/* IzAI */
			if( yy > ye || (yy == ye && mm > me) || (yy == ye && mm == me && dd > de) ) break;
			if( (rc = zmd_td1(g, &td, yy, mm, dd)) < 0 ) continue;
			                           CHKB(0, td, g.endtd);
			if( (rc = g.kimatu.push_back(td)) < 0 ) goto                 quit;
			++cnt;
		}
		/* for(;;)rbreakĂI */
		if( k < k0 ) break;
	}
	rc = cnt; //g.kiend.n;
quit:
	return rc;
}

/*	ID_zmd_kimatu	̔z
********************************************************/
int zmd_kimatu( ZMRP &g )
{
	int		ashm, rc;

	/* ̔z */
	g.kimatu.clear();
	for( ashm = 0; ashm < g.shm.n; ++ashm ) {
		g.shm.v[ashm].kimatubgn = g.kimatu.n;
		if( (rc = zmd_kimatu1(g, g.shm.v[ashm].yendmd / 100, g.shm.v[ashm].yendmd % 100, g.shm.v[ashm].kaisu )) < 0 ) goto quit;
		if( rc <= 0 ) {	    /* ԓɊȂ */
			if( (rc = g.kimatu.push_back(g.endtd)) < 0 ) goto quit;  /* _~[쐬 */
		}
		g.shm.v[ashm].kimatuend = g.kimatu.n - 1;
	}
	rc = 0;
quit:
	return rc;
}
