/*
 * FILE      : zfsmulsa1.cpp	bgvZ(gpVbv)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : bgvZ(gpVbv)
 * AUTHOR    : N.Tsuchiya  2004.08.30, F.Sasaki 2004/09/30
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/* 35.bgvZƓ */ 

/*	ID_zfSMULSA1_proc	8.bgvZ
********************************************************/
int zfSMULSA1_proc( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh, int dbgf) /* rc 0: <0:ُ */
{
	int		rc = 0, atrp1, atrp2, aodm, due, lastusetd;
	double	size;
	trp1_td	*wtrp1;
	trp2_td	wtrp2, *ptrp2;
	            CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if(dbgf) {TRACEA(0); Dprintf("zfSMULSA1_proc nodtyp(%d) ashm(%d) aitm(%d) atsh(%d) dbgf(%d)" CR, nodtyp, ashm, aitm, atsh, dbgf );}
	/* qiڂ̎gpVbv̔ԍ */
	atsh = zfGetTsh(g, aitm, ashm, atsh); CHKA(0, atsh, g.tsh.n);
	if ( atsh < 0 || atsh >= g.tsh.n ) goto                     quit;

	for( atrp1 = g.tsh.v[atsh].toptrp1; atrp1 >= 0; atrp1 = wtrp1->daynext ) { CHKA(0, atrp1, g.trp1.n);
		if ( atrp1 >= g.trp1.n ) goto                                   quit;
		/* lqoo */
		wtrp1 = &g.trp1[atrp1];     CHKB(atsh, wtrp1->tsh, atsh);
		due   = wtrp1->due;         CHKB(0, due, g.endtd);
		aodm  = wtrp1->odm;         CHKA(0, aodm, g.odm.n);/*  \                                 odm[] */
		lastusetd = wtrp1->lastusetd;   /*  ŏIgp\i܂ƂߑΏۂTRP1̍ŏIgp\j */
		size  = wtrp1->net;        /*    */
		if( ISZERO(size) ) continue;
		/* TRP2R[hɒǉ */
		if( (rc = zfAddTrp2( g, wtrp2, aodm, atsh, size, due, lastusetd)) < 0 ) goto    quit;
		atrp2 = rc;
		ptrp2 = &g.trp2[atrp2]; CHKA(0, atrp2, g.trp2.n);
		/* bg܂Ƃߏڍׂɒǉ */
		if( (rc = zfAddLsz(g, 1, &wtrp1->topkolsz1, &ptrp2->topoylsz1, atrp1, atrp2, size)) < 0 ) goto quit;
	}
	rc = 0;
quit:
	if(dbgf) {TRACEC(0); Dprintf("zfSMULSA1_proc rc(%d)" CR, rc);}
	return( rc );
}
/*	ID_zfSMULSA1	8.bgvZ
********************************************************/
int zfSMULSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh) /* rc 0: <0:ُ */
{
	int		rc = 0;
	            CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if(zdbgf[99]) {Dprintf(" 8.zfSMULSA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); goto quit;}
	/* bgvZ */
	rc = zfSMULSA1_proc(g, nodtyp, ashm, aitm, atsh, zdbgf[108]);
quit:
	return( rc );
}
